function SocketConnector(OSs){
  if(arguments.callee._singletonInstance){
    return arguments.callee._singletonInstance;
  }
  arguments.callee._singletonInstance = this;
  var self = this; self.name = "SocketConnector"; // MANDATORY

  this.socketControl = null;
  this.connectSocket = false;
  this.version = "sck2.0.4";
  this.namePlayer = null;
  this.OS = OSs;
  this.createSocketVar = false;
  this.logActive = false;
  this.timerLogActive = 0;
  this.who_am_i = "";

  this.protocol = "http://";
  this.control_socket_server_url = "socket.control.admira.com:3003/";
  this.connection_options = {"transports": ['websocket','polling'], "secure": false, "force new connection":false, "timeout":20000, "reconnection": true, "reconnectionDelay": 20000, "reconnectionDelayMax" : 25000, "reconnectionAttempts" :20};

  this.platformSocket = self.OS.platform;

  this.setWhoAmI = function(name){
    self.who_am_i = name;
  };

  this.setSecureConnection = function(activate){
    if(typeof(activate) === "undefined"){activate = false;}
    this.control_socket_server_url = "socket.control.admira.com/";
    if(activate){
      self.protocol = "https://";
      self.control_socket_server_url = "socket.control.admira.com/";
      self.connection_options = {"transports": ['websocket','polling'], "secure": true, "force new connection":false, "timeout":20000, "reconnection": true, "reconnectionDelay": 20000, "reconnectionDelayMax" : 25000, "reconnectionAttempts" :20};
    }else{
      self.protocol = "http://";
      self.control_socket_server_url = "socket.control.admira.com:3003/";
      self.connection_options = {"transports": ['websocket','polling'], "secure": false, "force new connection":false, "timeout":20000, "reconnection": true, "reconnectionDelay": 20000, "reconnectionDelayMax" : 25000, "reconnectionAttempts" :20};
    }
    self.disconnectSocket();
    setTimeout(function(){self.initSocket();}, 5000);
  };

  this.initSocket = function(){
    if(self.socketControl === null && self.connectSocket === false && self.createSocketVar === true){
      self.platformSocket = self.OS.platform;
      if(self.OS.platform == "WIN"){
        self.platformSocket = "WINNEW";
      }
      self.socketControl = io.connect(self.protocol+self.control_socket_server_url+self.platformSocket,self.connection_options);
      self.socketControl.on("connect_error", function(err){
        if(self.protocol == "http://"){
          self.protocol = "https://";
          self.control_socket_server_url = "socket.control.admira.com/";
          self.socketControl.io.uri = self.protocol+self.control_socket_server_url+self.platformSocket;
        }
        else{
          if(self.protocol == "https://"){
            self.protocol = "http://";
            self.control_socket_server_url = "socket.control.admira.com:3003/";
            self.socketControl.io.uri = self.protocol+self.control_socket_server_url+self.platformSocket;
          }
        }
      });

      self.socketControl.on('connect', function(){
        self.socketControl.emit('room.join', {room: self.OS.core_id});
        self.namePlayer = self.OS.core_id;
      });
      self.socketControl.on('room.join.response', function(data){
        self.connectSocket = true;
        self.logsSocket("SocketConnector", data);
      });
      /*self.socketControl.on('disconnect', function(){
        self.socketControl.destroy();
        delete self.socketControl;
        self.socketControl = null;
        self.connectSocket = false;
      })*/
      self.socketControl.on('reboot', function(data){
        self.responseSocket("------------------------------------------------reboot");
        self.logsSocket("SocketConnector", "------------------------------------------------reboot");
        setTimeout(function(){self.OS.rebootSystem();},5000);
      });
      self.socketControl.on('getLic', function(data){
        self.responseSocket("------------------------------------------------getLic");
        self.OS.getLIC(function(result){
          self.responseSocket(result);
        })
      });
      self.socketControl.on("createLIC", function(data){
          self.responseSocket("------------------------------------------------createLIC");
          self.OS.createLIC(data, function(result){
            self.responseSocket(result);
          })
      });
      self.socketControl.on('deleteAll', function(data){
        self.responseSocket("------------------------------------------------deleteAll");
        self.OS.deleteAll(function(result){
          self.responseSocket(result);
        })
      });
      self.socketControl.on('deleteAllAll', function(data){
        self.responseSocket("------------------------------------------------deleteAllAll");
        self.OS.deleteAllAll(function(result){
          self.responseSocket(result);
        });
      });
      self.socketControl.on('getInfo', function(data){
        self.responseSocket("------------------------------------------------getInfo");
        self.OS.getInfoSystem(function(result){
          self.responseSocket(result);
        });
      });
      self.socketControl.on('getInfoPlus', function(data){
        self.responseSocket("------------------------------------------------getInfoSystemPlus");
        self.OS.getInfoSystemPlus(function(result){
          self.responseSocket(result);
        });
      });
      /*main_webos.socketControl.on('getPowerOnOffHistory', function(data){
          main_webos.logsSocket("socketControl", "------------------------------------------------getPowerOnOffHistory: ");
          transfer.OS.getPowerOnOffHistory(function(err, result){
              if(err){
                  main_webos.logsSocket("socketControl", JSON.stringify(err));
              }
              else{
                  main_webos.logsSocket("socketControl", JSON.stringify(result));
              }
          });
      });*/
      self.socketControl.on('getTimers', function(data){
        self.responseSocket("------------------------------------------------getTimers");
        self.OS.getTimers(function(result){
          self.responseSocket(JSON.stringify(result));
        });
      });

      self.socketControl.on('forceAlive', function(data){
          self.responseSocket("------------------------------------------------forceAlive");
          var data = self.OS.getAliveData();
          self.OS.api_connector.post(self.OS.api_url,self.OS.api_ver,"player/alive",data,self.OS.aliveResponse);

      });

      self.socketControl.on("getScreenshot", function(data){
          self.responseSocket("------------------------------------------------getScreenshot");
          self.OS.getScreenshot(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('getStatusPanel', function(data){
          self.responseSocket("------------------------------------------------getStatusPanel: ");
          self.OS.getStatusPanel(function(err, result){
              if(result != undefined && result != null){
                  self.responseSocket(result);
              }
              else{
                  self.responseSocket(err);
              }

          });
      });
      self.socketControl.on('setPanelOff', function(data){
          self.responseSocket("------------------------------------------------setPanelOff: ");
          self.OS.setPanelOff(function(err, result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('setPanelOn', function(data){
          self.responseSocket("------------------------------------------------setPanelOn: ");
          self.OS.setPanelOn(function(err, result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on("updateFirmware", function(data){
        self.responseSocket("------------------------------------------------updateFirmware");
        self.OS.updateFirmware(data, function(result){
          self.responseSocket(result);
        })
      })
      /* usados en webos */
      self.socketControl.on('clearCache', function(data){
          self.responseSocket("------------------------------------------------clearCache: ");
          self.OS.clearCache(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('calculateReboot', function(data){
          self.responseSocket("------------------------------------------------calculateReboot: ");
          self.OS.calculateReboot(function(result){
            self.responseSocket(result);
          });
      });



      self.socketControl.on('upgradeApplication', function(data){
          self.responseSocket("------------------------------------------------upgradeApplication: ");
          self.OS.upgradeApplication(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('upgradeApplicationInstall', function(data){
          self.responseSocket("------------------------------------------------upgradeApplicationInstall: ");
          self.OS.upgradeApplicationInstall(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('upgradeApplicationInsert', function(data){
          self.responseSocket("------------------------------------------------upgradeApplicationInsert: ");
          self.OS.upgradeApplicationInsert(data.url, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('upgradeApplicationNow', function(data){
          self.responseSocket("------------------------------------------------upgradeApplicationInstall: ");
          self.OS.upgradeApplicationNow(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('updateApplicationS', function(data){
          self.responseSocket("------------------------------------------------updateApplicationS: ");
          self.OS.updateApplicationS(data.data, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('changePictureMode', function(data){
          self.responseSocket("------------------------------------------------changePictureMode: ");
          self.OS.changePictureMode(data.mode, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('getPictureProperty', function(data){
          self.responseSocket("------------------------------------------------getPictureProperty: ");
          self.OS.getPictureProperty(function(result){
            self.responseSocket(result);
          });
      });
     /* self.socketControl.on('setURLLauncher', function(data){
          self.responseSocket("------------------------------------------------setURLLauncher: ");
          self.OS.setURLLauncher(data.data, function(result){
            self.responseSocket(result);
          });
      });
      */
      self.socketControl.on('setPortraitMode', function(data){
          self.responseSocket("------------------------------------------------setPortraitMode: "+ data.mode);
          var se=data.mode;
//          self.OS.setMode(data, function(result){
          self.OS.setNativePortraitMode(se, data.mode, function(result){
            self.responseSocket(result);
          })
      });
      self.socketControl.on('getContentRotation', function(data){
          self.responseSocket("------------------------------------------------getContentRotation: ");
          /*self.OS.getContentRotation(function(err, result){
              if(err){
                  self.responseSocket(JSON.stringify(err));
              }
              else{
                  self.responseSocket(result);
              }
          });*/
          self.OS.getNativePortraitMode(function(result){
            self.responseSocket(result);
          })
      });
      self.socketControl.on('setContentRotation', function(data){
          self.responseSocket("------------------------------------------------setContentRotation: "+ data.degree + " .. "+ data.aspectRatio);
          transfer.OS.setContentRotation({degree : data.degree, aspectRatio : data.aspectRatio}, function(err, result){
              if(err){
                  self.responseSocket(JSON.stringify(err));
              }
              else{
                  self.responseSocket(result);
              }
          });
      });
      self.socketControl.on('getVideoStatus', function(data){
          self.responseSocket("------------------------------------------------getVideoStatus: ");
          self.OS.getVideoStatus(function(err, result){
              if(err){
                  self.responseSocket(JSON.stringify(err));
              }
              else{
                  self.responseSocket(result);
              }
          });
      });
      self.socketControl.on('setFailoverMode', function(data){
          self.responseSocket("------------------------------------------------setFailoverMode: ");
          self.OS.setFailoverMode(data.mode, data.priority, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('getFailoverMode', function(data){
          self.responseSocket("------------------------------------------------getFailoverMode: ");
          self.OS.getFailoverMode(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('hdmiControlMode', function(data){
          self.responseSocket("------------------------------------------------hdmiControlMode: ");
          var displayHDMI = $('<div id="HDMIScreen" style="position:absolute;left:0px;top:0px;z-index:103;width:100%;"></div>');
          $("body").append(displayHDMI);
          self.OS.HDMIscreen(function(result){
            self.responseSocket(result);
          });
      });
      /* usados en soc */
      self.socketControl.on("copyUSB", function(data){
          self.responseSocket("------------------------------------------------copyUSB");
          self.OS.copyUSB(function(result){
            self.responseSocket(result);
          });
      })
      self.socketControl.on("deleteAndCopyUSB", function(data){
          self.responseSocket("------------------------------------------------deleteAndCopyUSB");
          self.OS.deleteAll2(function(result){
            self.responseSocket(result);
          });
      })
      self.socketControl.on('getFiles', function(data){
        self.responseSocket("-------------------------------------------getFiles");
        transfer.OS.listFilesDirectory(data.dir, function(result){
          self.responseSocket(result);
        });
      });
      /* use android */
      self.socketControl.on('exitKioskMode', function(data){
        self.responseSocket("-------------------------------------------exitKioskMode");
        transfer.OS.exitKioskMode(function(result){
          self.responseSocket(result);
        });
      })
      self.socketControl.on('getStatusKioskMode', function(data){
        self.responseSocket("-------------------------------------------getStatusKioskMode");
        transfer.OS.getStatusKioskMode(function(result){
          self.responseSocket(result);
        });
      })
      self.socketControl.on('getPowerOnOffHistory', function(data){
        self.responseSocket("------------------------------------------------getPowerOnOffHistory");
        self.OS.getPowerOnOffHistory(function(result){
          self.responseSocket(result);
        });
      });


      self.socketControl.on('getBrigthness', function(data){
          self.responseSocket("------------------------------------------------getBrigthness: ");
          self.OS.getBrigthness(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('setBrightness', function(data){
          self.responseSocket("------------------------------------------------setBrightness: "+data.brightness);
          self.OS.setBrightness(data.brightness, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('getContrast', function(data){
          self.responseSocket("------------------------------------------------getContrast: ");
          self.OS.getContrast(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('setContrast', function(data){
          self.responseSocket("------------------------------------------------setContrast: "+data.contrast);
          self.OS.setContrast(data.contrast, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('getBacklight', function(data){
          self.responseSocket("------------------------------------------------getBacklight: ");
          self.OS.getBacklight(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('setBacklight', function(data){
          self.responseSocket("------------------------------------------------setBacklight: "+data.backlight);
          self.OS.setBacklight(data.backlight, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('geConfigPanel', function(data){
          self.responseSocket("------------------------------------------------geConfigPanel: ");
          self.OS.geConfigPanel(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('setConfigPanel', function(data){
          self.responseSocket("------------------------------------------------setConfigPanel: "+data);
          self.OS.setConfigPanel(data, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('getStatusRemoteControl', function(data){
          self.responseSocket("------------------------------------------------getStatusRemoteControl: ");
          self.OS.getStatusRemoteControl(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('setStatusRemoteControl', function(data){
          self.responseSocket("------------------------------------------------setStatusRemoteControl: "+data.remote);
          self.OS.setStatusRemoteControl(data.remote, function(result){
            self.responseSocket(result);
          });
      });


      self.socketControl.on('setSystemDateTimeNTPOFF', function(data){
          self.responseSocket("------------------------------------------------setSystemDateTimeNTPOFF: ");
          self.OS.setSystemDateTimeNTP(false,function(result){
            self.responseSocket("finished setSystemDateTimeNTPOFF");
          });
      });
      self.socketControl.on('setSystemDateTimeNTPON', function(data){
          self.responseSocket("------------------------------------------------setSystemDateTimeNTPON: ");
          self.OS.setSystemDateTimeNTP(true,function(result){
            self.responseSocket("finished setSystemDateTimeNTPON");
          });
      });
      self.socketControl.on('setTimeZoneSocket', function(data){
          self.responseSocket("------------------------------------------------setTimeZoneSocket: ");
          self.logsSocket("SocketConnector", data.timezone);
          self.OS.setTimeZoneSocket(data.timezone,function(result){
            self.responseSocket("finished setTimeZoneSocket");
          });
      });
      self.socketControl.on('initSendLog', function(data){
          self.responseSocket("------------------------------------------------initSendLog");
          self.logActive = true;
          clearTimeout(self.timerLogActive);
          self.timerLogActive = setTimeout(function(){self.logActive = false;}, 600000);
      });
      self.socketControl.on('endSendLog', function(data){
          self.responseSocket("------------------------------------------------endSendLog");
          self.logActive = false;
          clearTimeout(self.timerLogActive);
      });

      self.socketControl.on('setVolume', function(data){
          self.responseSocket("------------------------------------------------setVolume: "+data.volume);
          if(typeof(data.device_options) !== "undefined" && data.device_options !== null){
            self.OS.socketSetVolume(data.volume,data.device_options);
          }else if(typeof(data.device) !== "undefined"){
            self.OS.socketSetVolume(data.volume,{'internal_id':data.device,'gain':data.volume});
          }else{
            self.OS.socketSetVolume(data.volume);
          }
      });
      self.socketControl.on('getVolume', function(data){
          self.responseSocket("------------------------------------------------getVolume");
          var volume_info = {
            volume:self.OS.volume,
            who_am_i:self.who_am_i
          }
          if(self.OS.audioController){
            volume_info.devices = [];
            var contollerInfo = self.OS.audioController.getDefaultAudioOptions();
            for(var i=0;i<contollerInfo.channels.length;i++){
              volume_info.devices.push({
                internal_id:contollerInfo.channels[i].internal_id,
                channel:contollerInfo.channels[i].channel,
                gain:contollerInfo.channels[i].gain});
            }
          }
          self.responseSocket(volume_info);
      });
      self.socketControl.on('setVolumeSO', function(data){
          self.responseSocket("------------------------------------------------setVolumeSO: "+data.volume);
          self.responseSocket("functionality under construction");
          // self.OS.setVolume(data.volume, function(result){
          //   self.responseSocket(result);
          // });
      });
    }
  };
  this.logsSocket = function(type, data){
    if(self.connectSocket === true && self.logActive){
      self.socketControl.emit('logs', {namePlayer: self.namePlayer, version: self.version, type: type, data: data, who_am_i:self.who_am_i});
    }
  };
  this.responseSocket = function(type, data){
    if(self.connectSocket === true){
      self.socketControl.emit('response', {namePlayer: self.namePlayer, version: self.version, type: type, data: data, who_am_i:self.who_am_i});
    }
  };
  this.disconnectSocket = function(){

    if (self.socketControl != null){
      if(self.OS.core_id != null && self.OS.core_id != "0") {
        self.socketControl.disconnect();
        self.socketControl.destroy();
        delete self.socketControl;
        self.connectSocket = false;
        self.socketControl = null;
        self.createSocketVar = false;
      }
    }
  }
  this.createSocket = function(){
    self.createSocketVar = true;
    self.logsSocket("SocketConnector", "------------------------------- createSocket ----------------------------");
    self.logsSocket("SocketConnector", self.namePlayer + "       "+self.OS.core_id);
    if(self.socketControl === null){
      self.logsSocket("SocketConnector", "------------------------------- createSocket socketControl = null ----------------------------");
      self.initSocket();
    }
    else{
      if(self.namePlayer != self.OS.core_id){
        self.logsSocket("SocketConnector", "------------------------------- createSocket ids distintos ----------------------------");
        self.disconnectSocket();
        setTimeout(function(){self.createSocketVar = true;self.initSocket();}, 5000);
      }
    }
  }
  this.changeCore = function(id){
    self.logsSocket("SocketConnector", "---------------------------------changeCore--------------------------");
    self.logsSocket("SocketConnector", self.namePlayer + "       "+self.OS.core_id+ "     " + id);
    if(id != self.OS.core_id){
      self.logsSocket("SocketConnector", "---------------------------------changeCore - ids distintos --------------------------");
      self.OS.core_id = id;
      self.disconnectSocket();
      setTimeout(function(){self.initSocket();}, 5000);
    }
  }
}
//socketConnector.prototype = new SystemController();
